var serverURL = 'avd.nice2meet.cn:9609'; 

var accessKey = 'demo_access';
var secretKey = 'demo_secret';
var accessToken = null;

var AVDEngine = ModuleBase.use(ModulesEnum.avdEngine);  
var avdEngine = new AVDEngine();
avdEngine.setLog(Appender.browserConsole, LogLevel.debug);

var restApi = new RestApi(serverURL);

var client,chatManager;
var self = this;

restApi.getAccessToken (accessKey , secretKey).then((res) => {
    console.log('Success',res)
    accessToken = res.token;
}).baseVideo((error) => {
    console.log("Error",error);
    $("#loginMsg").html('getAccessToken(),error:'+error.msg);
})


function login() {
	var account = $("#account").val();
	var password = $("#password").val();
    if(account == '') {
        $("#loginMsg").html('用户帐号不能为空');
        return
    }

    var Client = ModuleBase.use(ModulesEnum.client);
    client = new Client(serverURL, accessToken);
    
    client.login(account,password).then(function(){
        console.log('信令注册登录成功');
        $("#loginMsg").html('登录成功,用户帐号:' + account);
        // registerClientCallback();//暂时没用到  TODO 
        
        chatManager = client.getChatManager(); 
        registerChatManagerCallback();
    }).otherwise(function(error){ 
        console.log('信令注册登录失败！'+ error.message+ "["+error.code+']');
        $("#loginMsg").html('信令注册登录失败！'+ error.message+ "["+error.code+']');
    });
}

function registerGroups(){
	 var groupIds = $("#groupIds").val();
	 if(groupIds == '') {
        $("#registerGroupsMsg").html('群组ID不能为空');
        return
     }
	 
	 $("#registerGroupsMsg").html('');
	 if(groupIds && chatManager){
	 	   var groupIdsSp = groupIds.split(',');
	 	   chatManager.registerGroups(groupIdsSp);
	 }
}

function unregisterGroup(){
	 var groupId = $("#groupId").val();
	 if(groupId == '') {
        $("#unregisterGroupMsg").html('群组ID不能为空');
        return
     }
	 
	 $("#unregisterGroupMsg").html('');
	 if(groupId && chatManager){
	 	   chatManager.unregisterGroup(groupId);
	 }
}

function  messageSend(){
	 var sessionType = parseInt($("#sessionType").val());
	 var sessionId = $("#sessionId").val();
	 var messageContent = $("#messageContent").val();
	 
	 
	 if(sessionId == '') {
        $("#sendMessageMsg").html('对方userId或群组Id或聊天室ID不能为空');
        return
     }
	 
	 if(messageContent == '') {
        $("#sendMessageMsg").html('聊天内容不能为空');
        return
     }
	 $("#sendMessageMsg").html('');
	 
	 if(chatManager){
	 	   var textMessage = chatManager.newTextMessage(sessionType,sessionId,messageContent);
	 	   chatManager.sendMessage(textMessage).then(function(){
	 	   	     messageSendSuccess(textMessage);
	 	   }).otherwise(function(error){ 
                console.log('消息发送失败！'+ error.code+'/'+error.message); 
                $("#sendMessageMsg").html('消息发送失败！'+ error.code+'/'+error.message);
           });
	 }
}


/**
 * 注册ChatManager级别回调 
 */
function registerChatManagerCallback(){
    chatManager.addCallback(chatManager.ChatManagerCallbackEnum.RECEIVE_MESSAGE_NOTIFY, onReceiveMessageNotify);
    chatManager.addCallback(chatManager.ChatManagerCallbackEnum.MESSAGE_STATUS_CHANGED_NOTIFY, onMessageStatusChangedNotify);
}

function onReceiveMessageNotify(message){
	console.log("==================onReceiveMessageNotify(),message:",message);
	messageSendSuccess(message);
}

function onMessageStatusChangedNotify(messageStatus,sessionId,sesstionType,messageId){
	console.log("==================onMessageStatusChangedNotify(),messageId:",messageId);
}

function messageSendSuccess(message) {
	var val = document.getElementById("messageColl").innerHTML;
	var prefix = "";
	if(!strUtil.isEmpty(val)) {
		prefix = "\r\n";
	}
	val += prefix + new Date(message.createTime).format("yyyy-MM-dd hh:mm:ss") + " " + message.sendUserId + "：" + message.content;
	document.getElementById("messageColl").innerHTML = val;
	document.getElementById("messageContent").value = "";
	document.getElementById("messageContent").focus();
}

Date.prototype.format = function(fmt) { 
     var o = { 
        "M+" : this.getMonth()+1,                 //月份 
        "d+" : this.getDate(),                    //日 
        "h+" : this.getHours(),                   //小时 
        "m+" : this.getMinutes(),                 //分 
        "s+" : this.getSeconds(),                 //秒 
        "q+" : Math.floor((this.getMonth()+3)/3), //季度 
        "S"  : this.getMilliseconds()             //毫秒 
    }; 
    if(/(y+)/.test(fmt)) {
            fmt=fmt.replace(RegExp.$1, (this.getFullYear()+"").substr(4 - RegExp.$1.length)); 
    }
     for(var k in o) {
        if(new RegExp("("+ k +")").test(fmt)){
             fmt = fmt.replace(RegExp.$1, (RegExp.$1.length==1) ? (o[k]) : (("00"+ o[k]).substr((""+ o[k]).length)));
         }
     }
    return fmt; 
} 
 


/**
 * 字符串相关处理
 */
var strUtil = {
	/*
	 * 判断字符串是否为空
	 * @param str 传入的字符串
	 * @returns {}
	 */
	isEmpty: function(str) {
		if(str != null && str.length > 0) {
			return false;
		} else {
			return true;
		}
	}
}
