var serverURL = 'box.nice2meet.cn';

var accessKey = 'demo_access';
var secretKey = 'demo_secret';
var accessToken = null;

var AVDEngine = ModuleBase.use(ModulesEnum.avdEngine);  
var avdEngine = new AVDEngine();
avdEngine.setLog(Appender.browserConsole, LogLevel.debug);

var restApi = new RestApi(serverURL);

var client,inviteManager,acceptInvite,callInvite, invite;
var self = this;

restApi.getAccessToken (accessKey , secretKey).then((res) => {
    console.log('Success',res)
    accessToken = res.token;
}).otherwise((error) => {
    console.log("Error",error);
    $(".loginMsg").html('getAccessToken(),error:'+error.msg);
})

function login() {
	var account = $('#account').val();
	var passwrod = $('#passwrod').val();
    if(account == '') {
        $(".loginMsg").html('用户帐号不能为空');
        return
    }

    var Client = ModuleBase.use(ModulesEnum.client);
    client = new Client(serverURL, accessToken);
    
    client.login(account,passwrod).then(function(){
        console.log('信令注册登录成功');
        $(".loginMsg").html('登录成功,用户帐号:' + account);
        // registerClientCallback();//暂时没用到  TODO 
        client.nativeSubscribe('participants_organization');
        inviteManager = client.getInviteManager(); 
        registerInviteManagerCallback();
    }).otherwise(function(error){ 
        console.log('信令注册登录失败！'+ error.message+"["+error.code+']'); 
        $(".loginMsg").html('信令注册登录失败！'+ error.message+"["+error.code+']'); 
    });
}

/**
 * 注册InviteManager级别回调 
 */
function registerInviteManagerCallback(){
    inviteManager.addCallback(inviteManager.InviteManagerCallbackEnum.CALL_NOTIFY, onCall);
}

/**
 * 注册Invite级别回调 
 */
function registerInviteCallback(invite){
    invite.addCallback(invite.InviteCallbackEnum.CALL_ACCEPT_NOTIFY, onCallAccept);
    invite.addCallback(invite.InviteCallbackEnum.CALL_REJECT_NOTIFY, onCallReject);
    invite.addCallback(invite.InviteCallbackEnum.CALL_TIMEOUT_NOTIFY, onCallTimeout);
    invite.addCallback(invite.InviteCallbackEnum.CALL_RINGING_NOTIFY, onCallRinging);
    
    invite.addCallback(invite.InviteCallbackEnum.CALL_CANCEL_NOTIFY, onCallCancel);
    invite.addCallback(invite.InviteCallbackEnum.RESPONSE_CALL_TIMEOUT_NOTIFY, onResponseCallTimeout);
    
    invite.addCallback(invite.InviteCallbackEnum.CALL_CLOSE_NOTIFY, onCallClose);
}

function call() {
    if(!client) {
        $('.loginMsg').html('请先登录');
        return
    }
    var onCallId = $('#onCallId').val();
    if( onCallId == '') {
        $('.inviteMsg').html('对方用户帐号不能为空!');
        return
    }

    var options = {
        'remoteControlType': 'master'
    }

    callInvite = self.inviteManager.createInvite($('#account').val(), onCallId, options);
    registerInviteCallback(callInvite);

    inviteManager.call(callInvite).then(() => {
        console.log('邀请发送成功!');
        $('.inviteMsg').html('邀请发送成功,等待对方接受...');
    }).otherwise((error) => {
        log.error('邀请发送失败！' + error.code + '/' + error.message);
        $('.inviteMsg').html('邀请发送失败！' + error.code + '/' + error.message);
    })
}

function onCall(invite){
    acceptInvite = invite;
    registerInviteCallback(invite);
    self.invite = invite;

    invite.ringing().then(function(){
        console.log("发送振铃成功");	   	
        $('.onCallIsShow').css({
            'display': 'block'
        })
        if (invite.options.remoteControlType == 'master') {
            $('.onCallMsg').html(invite.toUserId+'向您发送邀请,请选择接受或者拒绝该请求。');
        }
    }).otherwise(function(error){
        log.error("发送振铃失败。error：",error);
        $('.inviteMsg').html("发送振铃失败。error：",error)
    })
}

// 邀请请求已被接受的回调
function onCallAccept(toUserId, options) {
    console.log("======onCallAccept()=====toUserId:"+toUserId+";options:"+options);
    $('.inviteMsg').html('对方接受邀请成功');
}

// 邀请请求已被拒绝的回调
function onCallReject(toUserId,reson){
    console.log("======onCallReject()=====toUserId:"+toUserId+";reson:" + reson);
    $('.inviteMsg').html('对方拒绝了邀请');
}

//邀请请求无响应，超时回调
function onCallTimeout(toUserId){
    console.log("======onCallTimeout()=====toUserId:"+toUserId);
    $('.inviteMsg').html('发送邀请对方无响应，已超时');
}

//邀请请求响铃回调
function onCallRinging(toUserId){
	console.log("======onCallRinging()=====toUserId:"+toUserId);
}


//邀请发启者取消邀请的回调
function onCallCancel(fromUserId){
	console.log("======onCallCancel()=====fromUserId:"+fromUserId);
}

//接收邀请者无响应，超时回调
function onResponseCallTimeout(fromUserId){
    console.log("======onResponseCallTimeout()=====fromUserId:"+fromUserId);
    $('.onCallIsShow').css({
        'display': 'none'
    })
    $('.inviteMessage').html('收到邀请，未作出响应，已超时');
}

function onCallClose(fromUserId,reson){
	console.log("======onCallClose()=====fromUserId:"+fromUserId+";reson:" + reson);
}

function accept() {
    $('.onCallIsShow').css({
        'display': 'none'
    })

    self.invite.accept().then(() => {
        console.log('接受邀请成功。');
        $('.inviteMessage').html('接受邀请成功。');
    }).otherwise(function (error) {
        log.error('接受邀请失败。error：', error);
        $('.inviteMessage').html('接受邀请失败。error：', error);
    })
}

function refuse() {
    $('.onCallIsShow').css({
        'display': 'none'
    })

    var reson = 'No reason'
    self.invite.reject(reson).then(function () {
        console.log('拒绝邀请成功。');
        $('.inviteMessage').html('拒绝邀请成功。');
    }).otherwise(function (error) {
        log.error('拒绝邀请失败。error：', error);
        $('.inviteMessage').html('拒绝邀请失败。error：', error);
    })
}

function hangUp(){
    if(callInvite){
        callInvite.close('hangUp').then(()=>{
            console.log('callInvite.close()成功');
        }).otherwise(()=>{
            console.log('callInvite.close()失败');
        })
    }

    if(acceptInvite){
        acceptInvite.close('hangUp').then(()=>{
            console.log('acceptInvite.close()成功');
        }).otherwise(()=>{
            console.log('acceptInvite.close()失败');
        })
    }

}