//本地工程环境运行时会走http协议，用dev.3tee.cn:81， nodejs环境运行时会走https协议，用dev.3tee.cn:441
var self = this;
var serverURL = 'dev.3tee.cn:81';
var accessKey = 'sdk2020_demo_access';
var secretKey = 'sdk2020_demo_secret';


// var serverURL = 'avd.nice2meet.cn:9609';
// var accessKey = 'SDKdemo_access';
// var secretKey = 'SDKdemo_secret';
var accessToken = null;

var roomId = null;
var userId = Math.uuid();
var userName = null;

var AVDEngine = ModuleBase.use(ModulesEnum.avdEngine);
var avdEngine = new AVDEngine();

$('#udpRadio').attr('checked', true);


avdEngine.setLog(Appender.browserConsole, LogLevel.debug);
avdEngine.initDevice();
avdEngine.setDefaultVideoParams(1080,720,ResolutionSetType.ideal,25,7000,9000);

$('input[type="radio"][name=mediaType]').change(function (){
    var value = $(this).val();
    if(value == 1){
        avdEngine.setMediaConnectType(1);  
        log.info('+++setMediaConnectType to ', value);     
    }
})

var restApi = new RestApi(serverURL);
var topic = 'testingMeeting';

var isOpenVideoShow = true;
var isOpenAudioShow = true;
var participants = [];

var localAudioId = '';

var chatNum = 0;

var singleLocalVideo;
var singleLocalVideoId = [];
var localVideo = document.getElementById('localVideo');
var localVideoId = '';

var num = 0;

var openMicrophoneUser = [];

//获取token
restApi.getAccessToken(accessKey, secretKey).then((res) => {
    console.log('Success', res)
    self.accessToken = res.token;
}).otherwise((error) => {
    console.log(error.msg);
    showHintMsg('getAccessToken(),error:' + error.msg);
})

//创建房间
function createRoom() {
    var topic = 'testingMeeting';
    restApi.createRoom(self.accessToken, topic, self.userId).then((res) => {
        console.log('Success', res)
        $("#meetingNum").val(res.room_id);
    }).otherwise((error) => {
        console.log("Error", error)
        showHintMsg('createRoom(),error:' + error.msg);
    })
}

function joinRoom() {
    if ($('#meetingNum').val() == "" && $('#userName').val() == "") {
        $('#meetingNum').css('border', '1px solid #f00');
        $('.meetingNumError').css('display', 'block');
        $('#userName').css('border', '1px solid #f00');
        $('.userNameError').css('display', 'block');
        return
    }
    if ($('#meetingNum').val() == "") {
        $('#meetingNum').css('border', '1px solid #f00');
        $('.meetingNumError').css('display', 'block');
        return
    }
    if ($('#userName').val() == "") {
        $('#userName').css('border', '1px solid #f00');
        $('.userNameError').css('display', 'block');
        return
    }

    self.roomId = $('#meetingNum').val();
    self.userName = $('#userName').val();
    restApi.createRoom(self.accessToken, topic, self.userId, self.roomId).then((res) => {
        console.log('==================createRoom()res:', res);
        avdEngine.init(self.serverURL, self.accessToken).then(initSuccess).otherwise(initError);
    }).otherwise((error) => {
        console.log('==================createRoom()error:', error.msg);
        if (error.ret == 40005) {
            //如果error.ret = 40005 说明房间已经存在
            avdEngine.init(self.serverURL, self.accessToken).then(initSuccess).otherwise(initError);
        } else {
            showHintMsg('createRoom(),error:error.ret:' + error.ret+'error.msg:' + error.msg);
        }
    })
}

//  初始化成功
function initSuccess() {
    room = avdEngine.obtainRoom(self.roomId);
    room.join(self.userId, self.userName, '', '').then(joinSuccess).otherwise(joinError);
}

//  初始化失败
function initError(error) {
    console.log('================initError()', error)
    console.log("AVDEngine 初始化失败！" + error.message);

    showHintMsg("AVDEngine 初始化失败！initError(),error:" + error.message);
}

//  加入房间成功
function joinSuccess() {
    console.log('===============joinSuccess()', '加入会议成功');

    $('.join').css('display', 'none');
    $('.onRoom').css('display', 'block');
    $('body').css('background', ' #222222');

    $('.meetingName').html(roomId);

    //注册房间回调
    registerRoomCallback();

    //加会登陆前，会议中已经发布的视频资源,采取订阅处理
    onPublishCameraNotify(room.pubVideos);
    
    //添加参会者列表内容
    participantContent();

    participantsHandle(room.getParticipants());
}

//添加参会者列表内容
function participantContent() {
    $('.content').empty();
    participants = room.getParticipants();

    $('.participantNum').html('(' + participants.length + ')');
    $('#participantList').html(participants.length);
    for (var i = 0; i < participants.length; i++) {
        var text = participants[i].name.substring(0, 1);
        $('.content').append(
            '<div id="' + participants[i].id + '" class="participant_item"><div class="participant_item_head">' + 
            text + '</div><div class="participant_item_name">' + participants[i].name + '</div><div class="participant_item_state">'+
             '<i class="icon_participantMir" id="'+participants[i].id+'Mir"></i><i class="icon_participantCam" id="'+participants[i].id+'Cam"></i>' +'</div></div>'
            );
        $('#messageUserId').append('<option value="' + participants[i].id + '">' + participants[i].name + '</option>')
    }
}

//  加入房间失败
function joinError(error) {
    console.log('joinError' + error.message);
    showHintMsg("joinError(),error: " + error.message);
}

$('.meetingName').html(GetQueryString('roomId'));
function GetQueryString(name) {
    var reg = new RegExp("(^|&)" + name + "=([^&]*)(&|$)", "i");
    var r = window.location.search.substr(1).match(reg);
    if (r != null) {
        return unescape(r[2]);
    }
    return 0;
}

//注册房间回调
function registerRoomCallback() {
    room.addCallback(RoomCallback.connection_status, onConnectionStatus);

    room.addCallback(RoomCallback.user_join_notify, onUserJoinNotify);
    room.addCallback(RoomCallback.user_leave_notify, onUserLeaveNotify);

    room.addCallback(RoomCallback.public_message, onPublicMessage);
	room.addCallback(RoomCallback.mcu_peerconnection_completed, onMCUPeerConnectionCompleted);
}

/**
 * @desc 网络状态回调
 */
function onConnectionStatus(status) {
    if(status == ConnectionStatus.connecting) {
        howHintMsg("网络故障,正在与服务器重连中...");
	} else if(status == ConnectionStatus.connected) {
		//连接成功
        howHintMsg("");
	} else if(status == ConnectionStatus.reJoinConnected) {
		//重新加会成功
        howHintMsg("");
	} else if(status == ConnectionStatus.reconnected) {
		//重连接成功
        howHintMsg("");
	} else if(status == ConnectionStatus.connectFailed) {
        howHintMsg("网络故障,与服务器重连超时，正在重新加会操作中...");

		//应用层清场
		if(room.connectionInfoCollector) {
			room.connectionInfoCollector.stop(); //停止收集网络情况
		}
	} else if(status == ConnectionStatus.reJoinRoomTimeOut) {
        howHintMsg("网络故障,重新加会中...");
	    room.continuousReJoin();
	}
}

/**
 * @desc 参会者加会回调
 * @param {Object} users － 参会者数组
 */
function onUserJoinNotify(users) {
    participantsHandle(users);

    //添加参会者列表内容
    participantContent();
    cameraLayout();
}

/**
 * @desc 参会者退会回调
 * @param {int} opt - 退会类型
 * @param {int} reason  - 退会原因
 * @param {Object} user - 退会用户
 */
function onUserLeaveNotify(opt, reason, user) {
	console.log("==========onUserLeaveNotify(),reason:",reason,",user:",user);
	
	//服务器端报807错误，说明UDP不通或UDP连接超时
	if(reason == 807) {
		showHintMsg("807错误，UDP不通或UDP连接超时！");
		return;
	}
	
	if(reason == 812){
		showHintMsg(user.name +" 已异常退会");
	}else{
		showHintMsg(user.name +" 已退会");
	}
	
	$('.participantNum').html('(' + participants.length -1 + ')');
	$('#participantList').html(participants.length -1);
	
    $('#' + user.id).remove();
    $("#messageUserId option").remove("option[value=" + user.id + "]");

    $('.video div').remove('div[id="' + user.id + '"]');
	
	cameraLayout();
}

/**
 * @desc  用户回调事件
 * @param {Object} participants - 用户集数组
 */
function participantsHandle(participants) {

    participants.forEach(function (user) {
        user.addCallback(UserCallback.camera_status_notify, onCameraStatusNotify);
        user.addCallback(UserCallback.microphone_status_notify, onMicrophoneStatusNotify);

        user.addCallback(UserCallback.publish_camera_notify, onPublishCameraNotify);
        user.addCallback(UserCallback.subscrible_camera_result, onSubscribleCameraResult);
        user.addCallback(UserCallback.unpublish_camera_notify, onUnpublishCameraNotify);
        user.addCallback(UserCallback.unsubscrible_camera_result, onUnsubscribleCameraResult);

        user.addCallback(UserCallback.subscrible_microphone_result, onSubscribleMicrophoneResult);
        user.addCallback(UserCallback.unsubscrible_microphone_result, onUnsubscribleMicrophoneResult);
    })
}

//退会
function leaveRoom() {
    if (!room) { return }
    var reason = 1; //退会原因
    room.leave(reason).then(function () {
        window.location.reload();
        return false;
    });
}

//打开摄像头

function openCamera() {
    if (isOpenVideoShow) {
        isOpenVideoShow = false;
        videos = room.selfUser.videos;
        if (videos && videos.length > 0 && $('#single')[0].checked) {
            var video = videos[0];
            if (video) {
                localVideoId = video.id;
                if($('.video').children().length == 4) {
                    isOpenVideoShow = true;
                    showHintMsg("视频最多允许4路");
                    return
                }
                if ($('.video').children().length < 4) {

                    $('.video').append('<div class="local" id="' + localVideoId + '"><video id="localVideo" autoplay muted></video></div>');
                }

                localVideo = document.getElementById('localVideo');
                video.previewAndPublish(localVideo).otherwise(showError);
            }
        } else {
            var videosNum = videos.length;
            
            // if (videos.length <= 3) {
            //     videosNum = videos.length;
            // } else {
            //     videosNum = 3;
            // }
            // if($('.video').children().length == 4) {
            //     isOpenVideoShow = true;
            //     showHintMsg("视频最多允许4路");
            //     return
            // }
            
            
            for (var i = 0; i < videosNum; i++) {
                var video = videos[i];
                singleLocalVideoId.push(videos[i].id);
                // if ($('.video').children().length < 4) {

                    $('.video').append('<div class="local" id="' + videos[i].id + '"><video id="localVideo' + i + '" autoplay muted></video></div>');
                // }

                singleLocalVideo = document.getElementById('localVideo' + i);

                video.previewAndPublish(singleLocalVideo).otherwise(showError);
            }
        }
        cameraLayout();
    }
}

//关闭摄像头
function closeCamera() {
    if (!isOpenVideoShow) {
        isOpenVideoShow = true;
        if ($('#single')[0].checked) {
            var video = room.selfUser.getVideo(self.localVideoId);
            $('.video div').remove('div[id="' + self.localVideoId + '"]');
            if (video) {
                video.unpreview();
                video.unpublish();
            }
        } else {
            for (var i = 0; i < singleLocalVideoId.length; i++) {
                var video = room.selfUser.getVideo(self.singleLocalVideoId[i]);
                $('.video div').remove('div[id="' + self.singleLocalVideoId[i] + '"]');
                if (video) {
                    video.unpreview();
                    video.unpublish();
                }
            }
        }
        cameraLayout();
    }
}

// 打开麦克风
function openMicrophone() {
    if (isOpenAudioShow) {
        isOpenAudioShow = false;
        var audio = room.selfUser.audio;
        localAudioId = audio.id;
        if (audio) {
            room.getParticipants().forEach(function(user){
                if(user.id == userId) {
                    openMicrophoneUser.push(user);
                }
            })
            audio.openMicrophone().otherwise(showError);
        }
    }
}

//关闭麦克风
function closeMicrophone() {
    if (!isOpenAudioShow) {
        isOpenAudioShow = true;
        var audio = room.selfUser.getAudio(self.localAudioId);
        if (audio) {
            openMicrophoneUser.forEach(function(user,index){
                if(user.id == userId) {
                    openMicrophoneUser.splice(index,1);
                }
            })
            audio.closeMicrophone();
        }
    }
}

function showError(error) {
    console.log('===============showError()error:', error);
    if(error.code == 800) {
        console.log('===============showError()error:', $('.video').children().length);
        if($('.video').children().length == 4) {
            showHintMsg("视频最多允许4路");
            return
        }
    }
    showHintMsg("showError()error.code" + error.code, + 'error.message:' + error.message);
}

/**
 * 摄像头状态更新
 * @param {Object} status － 状态
 * @param {Object} cameraId － 摄像头设备Id
 * @param {Object} cameraName－ 摄像头设备名称
 * @param {Object} userId－ 摄像头设备所属者ＩＤ
 */
function onCameraStatusNotify(status, cameraId, cameraName, userId) {
    var iconCam = document.getElementById(userId + 'Cam');
    if(status == 1) {
        iconCam.style.background = "url('./images/icon-participantCam-close.png') center center no-repeat";
        iconCam.style.backgroundSize = '100% 100%';
    } else {
        iconCam.style.background = "url('./images/icon-participantCam.png') center center no-repeat";
    }
    if (userId == room.selfUser.id) {
        if (status == StreamStatus.published) {
            $('#camera').removeClass('closeCamera');
            $('#camera').addClass('openCamera');
            $('.camera span').html('关闭视频');
        } else if (status == StreamStatus.init) {
            $('#camera').removeClass('openCamera');
            $('#camera').addClass('closeCamera');
            $('.camera span').html('开启视频');
        }
    }
}

/**
 * 麦克风状态更新
 * @param {Object} status － 状态
 * @param {Object} microphoneId － 麦克风设备Id 
 * @param {Object} microphoneName － 麦克风设备名称
 * @param {Object} userId － 麦克风设备所属者ＩＤ
 */
function onMicrophoneStatusNotify(status, microphoneId, microphoneName, userId) {
    var iconMir = document.getElementById(userId+"Mir");
    if(status == 1) {
        iconMir.style.background = "url('./images/icon-participantMir-close.png') center center no-repeat";
        iconMir.style.backgroundSize = '100% 100%';
    } else {
        iconMir.style.background = "url('./images/icon-participantMir.png') center center no-repeat";
    }
    if (userId == room.selfUser.id) {
        if (status == StreamStatus.published) {
            $('#microphone').removeClass('closeMicrophone');
            $('#microphone').addClass('openMicrophone');
            $('.microphone span').html('静音');
        } else if (status == StreamStatus.init) {
            $('#microphone').removeClass('openMicrophone');
            $('#microphone').addClass('closeMicrophone');
            $('.microphone span').html('解除静音');
        }
    }
}

//订阅未订阅的视频
function onPublishCameraNotify(videos) {
    videos.forEach(function (video) {
        //只订阅未订阅过的视频
        var subVideoIdsLen = room.selfUser.subVideoIds.length;
        if (subVideoIdsLen > 0) {
            var isSub = false;
            for (var i = 0; i < subVideoIdsLen; i++) {
                var videoId = room.selfUser.subVideoIds[i];
                if (video.id == videoId) {
                    isSub = true;
                    break;
                }
            }
            if (!isSub) {
                video.subscrible();
            }
        } else {
            video.subscrible();
        }
    });
}

/**
 * 订阅远端视频流反馈
 * @param {Object} stream － 远端视频流
 * @param {Object} userId － 所属用户ＩＤ
 * @param {Object} userName－ 所属用户名称
 * @param {Object} cameraId－ 摄像头设备ＩＤ
 */
function onSubscribleCameraResult(stream, userId, userName, cameraId) {
    num++;
    // if ($('.video').children().length < 4) {

        $('.video').append('<div class="local" id="' + userId + '"><video id="remoteVideo' + num + '" autoplay muted></video><audio autoplay></audio></div>');
    // }

    var remoteVideo = document.getElementById('remoteVideo' + num);
    room.selfUser.attachVideoElementMediaStream(remoteVideo, stream);
    cameraLayout();
}

/**
 * 房间中取消发布的视频回调
 * @param {Object} video-发布视频集
 */
function onUnpublishCameraNotify(video) {
    video.unsubscrible();
}

/**
 * 取消订阅远端视频流反馈
 * @param {Object} userId－ 所属用户ＩＤ
 * @param {Object} userName－所属用户名称
 * @param {Object} cameraId－摄像头设备ＩＤ
 */
function onUnsubscribleCameraResult(userId, userName, cameraId) {
    var remoteVideo = $('#' + userId).children('video')[0];
    room.selfUser.attachVideoElementMediaStream(remoteVideo, null);
    $('.video div').remove('div[id="' + userId + '"]');
    cameraLayout();
}

/**
 * 订阅远端音频流反馈
 * @param {Object} stream－ 远端音频流
 * @param {Object} userId－ 所属用户ＩＤ
 * @param {Object} userName－所属用户名称
 */
function onSubscribleMicrophoneResult(stream, userId, userName) {
    room.getParticipants().forEach(function(user){
        if(user.id == userId) {
            openMicrophoneUser.push(user);
        }
    })
    
    $('.audio').append('<audio id="' + userId + '" autoplay></audio>');
    var remoteAudio = $('.audio audio')[0];
    room.selfUser.attachAudioElementMediaStream(remoteAudio, stream);
}

/**
 * 取消订阅远端音频流反馈
 * @param {Object} userId－ 所属用户ＩＤ
 * @param {Object} userName－所属用户名称
 */
function onUnsubscribleMicrophoneResult(userId, userName) {
    openMicrophoneUser.forEach(function(user,index){
        if(user.id == userId) {
            openMicrophoneUser.splice(index,1);
        }
    })
    
    $('.audio audio').remove('audio[id="' + userId + '"]');
    var remoteAudio = $('.audio audio')[0];
    room.selfUser.attachAudioElementMediaStream(remoteAudio, null);
}

//打开参会者列表
function openParticipant() {
    $('.participant').css('display', 'block');
}

//关闭参会者窗口
$('.title img').click(() => {
    $('.participant').css('display', 'none');
})

//打开离开会议窗口
$('#leave').click(() => {
    $('.leave').css('display', 'block');
})

//关闭离开会议窗口
$('.leave_title img').click(() => {
    $('.leave').css('display', 'none');
})
$('.cancel').click(() => {
    $('.leave').css('display', 'none');
})

//打开聊天窗口
$('#chat').click(() => {
    $('.chat').css('display', 'block');
    $('.chatNum').css('opacity', '0');
    chatNum = 0;
})

//关闭聊天窗口
$('.chat_title img').click(() => {
    $('.chat').css('display', 'none');
})

//选择单双摄像头模式时，关闭摄像头
$('.cameraModel input').click(() => {
    cameraModel = false;
    $('.cameraModel').css('opacity', '0');
    closeCamera();
})

$('.cameraModel label').click(() => {
    cameraModel = false;
    $('.cameraModel').css('opacity', '0');
    closeCamera();
})

var cameraModel = false;
//打开或关闭摄像头模式
$('.smallBtn').click(() => {
    if (cameraModel == false) {
        cameraModel = true;
        $('.cameraModel').css('opacity', '1');
    } else {
        cameraModel = false;
        $('.cameraModel').css('opacity', '0');
    }
})

//发送聊天信息
function messageSend() {
    var msg = $('#message').val();
    room.sendPublicMessage(msg).then(messageSendSuccess(message)).otherwise(messageSendError);
}

function messageSendSuccess(message) {
    $('.chat_screen').append('<div class="chat_screen_text"><p class="name">' + room.selfUser.name + ':' + '</p><p class="text">' + message.value + '</p></div>');

    $('.chat_massage').empty();
    $('.chat_massage').append('<textarea placeholder="请输入消息..." id="message" onkeydown="if(event.keyCode==13) messageSend()"></textarea>');
    setTimeout(function () {
        $('.chat_screen').scrollTop($('.chat_screen').children().length * $('.chat_screen_text').height());
    }, 100)
}

function messageSendError(error) {
    $('.chat_screen').append('<div class="chat_screen_text">发送聊天信息失败！messageSendError()error:' + error + '</div>');

    showHintMsg("发送聊天信息失败 messageSendError(),error" + error.message);
}

/**
 * 公聊回调
 * @param {Object} Message
 */
function onPublicMessage(Message) {

    if (Message) {
        $('.chatNum').css('opacity', '1');
        chatNum++;

        $('.chatNum').html(chatNum);
    }
    $('.chat_screen').append('<div class="chat_screen_text"><p class="name">' + Message.fromName + ':' + '</p><p class="text">' + Message.message + '</p></div>');
}

function onMCUPeerConnectionCompleted() {
    var statsInterval = 500; //sdk语音激励计算频率
	room.audioLevel.start(statsInterval).then(audioLevelHandler); //开始语音激励
}

function audioLevelHandler() {
    var statsInterval = 1000; //应用层语音激励显示频率
    clearInterval(statsIntervalId);
    var statsIntervalId = setInterval(
        function() {
            if(room && openMicrophoneUser.length>0) {
                openMicrophoneUser.forEach(function(user) {
                    var iconMir = document.getElementById(user.id + 'Mir');
                    if(user.audio.getAudioLevel() >0 && user.audio.getAudioLevel()<=1) {
                        iconMir.style.background = 'url("./images/icon-low0.png") center center no-repeat'
                    } else if(user.audio.getAudioLevel() >1 && user.audio.getAudioLevel()<=3) {
                        iconMir.style.background = 'url("./images/icon-low1.png") center center no-repeat'
                    } else if(user.audio.getAudioLevel() >3 && user.audio.getAudioLevel()<=5) {
                        iconMir.style.background = 'url("./images/icon-low2.png") center center no-repeat'
                    } else if(user.audio.getAudioLevel() >5 && user.audio.getAudioLevel()<=7) {
                        iconMir.style.background = 'url("./images/icon-low3.png") center center no-repeat'
                    } else if(user.audio.getAudioLevel() >7 && user.audio.getAudioLevel()<=9) {
                        iconMir.style.background = 'url("./images/icon-low4.png") center center no-repeat'
                    }
                });
            }
        }, statsInterval);
    
	
}

//视频布局状态
function cameraLayout() {
    if ($('.video').children('div').length == 1) {
        $('.local').css({ 'width': '100%', 'height': '100%' });
    } else if ($('.video').children('div').length == 2) {
        $('.local').css({ 'width': '50%', 'height': '100%' });
    } else {
        $('.local').css({ 'width': '50%', 'height': '50%' });
    }
}

//显示提示信息
function showHintMsg(msg) {
    $('.hintMsg').html(msg);
    $('.hintMsg').css('display', 'block');
    setTimeout(() => {
        $('.hintMsg').css('display', 'none');
    }, 5000)
}

//双击进入全屏
function enterScreenFull() {
    if(f_IsFullScreen()) {
        exitFullscreen();
    } else {
        requestFullScreen();
    }
}

//进入全屏
 function requestFullScreen() {
    var de = document.documentElement;
    if (de.requestFullscreen) {
        de.requestFullscreen();
    } else if (de.mozRequestFullScreen) {
        de.mozRequestFullScreen();
    } else if (de.webkitRequestFullScreen) {
        de.webkitRequestFullScreen();
    }
}
 
 //退出全屏
 function exitFullscreen() {
    var de = document;
    if (de.exitFullscreen) {
        de.exitFullscreen();
    } else if (de.mozCancelFullScreen) {
        de.mozCancelFullScreen();
    } else if (de.webkitCancelFullScreen) {
        de.webkitCancelFullScreen();
    }
}

function f_IsFullScreen() {
    return (document.body.scrollHeight == window.screen.height && document.body.scrollWidth == window.screen.width);
}
