
// 鼠标
function chooseMouse() {
	currentBoard.annotation.setShapeType(shapeTypeEnum.mouse);
}

// 激光笔
function startHlightPoint() {
	currentBoard.annotation.startHlightPoint();
}

// 笔
function selectChangeType(shapeType) {
	if(shapeType == '999') {
		currentBoard.annotation.setShapeType(shapeTypeEnum.line);
		currentBoard.annotation.setArrowType(arrowTypeEnum.double);
	} else if(shapeType == '333') {
		currentBoard.annotation.setShapeType(shapeTypeEnum.rect);
		currentBoard.annotation.setFillColor(fillTypeEnum.full);
	} else {
		currentBoard.annotation.setArrowType(arrowTypeEnum.none);
		currentBoard.annotation.setShapeType(shapeType);
	}
}

// 橡皮擦
function clearAnnotation() {
	currentBoard.annotation.setShapeType(shapeTypeEnum.eraser, './img/board_eraser.png');
}

// 撤销
function undo() {
	currentBoard.annotation.undo();
}

// 清除
function eraser() {
	currentBoard.annotation.clear();
}

// 保存
function download() {
    var backgroundCanvas = document.getElementById('backgroundCanvas');
	currentBoard.annotation.download(backgroundCanvas);
}

var colorIpt = document.getElementById('colorIpt');
// 监听颜色变化
function selectToolColorChange(){
    var color = "rgba(" + colorRgb(colorIpt.value) + ")";
    currentBoard.annotation.setColor(color);
}


// 颜色值转化为rgba格式
function colorRgb(value){
    var sColor = value.toLowerCase();
    //十六进制颜色值的正则表达式
    var reg = /^#([0-9a-fA-f]{3}|[0-9a-fA-f]{6})$/;
    // 如果是16进制颜色
    if (sColor && reg.test(sColor)) {
        if (sColor.length === 4) {
            var sColorNew = "#";
            for (var i=1; i<4; i+=1) {
                sColorNew += sColor.slice(i, i+1).concat(sColor.slice(i, i+1));    
            }
            sColor = sColorNew;
        }
        //处理六位的颜色值
        var sColorChange = [];
        for (var i=1; i<7; i+=2) {
            sColorChange.push(parseInt("0x"+sColor.slice(i, i+2)));    
        }
        return sColorChange.join(",") + ",1";
    }
    return sColor;
}